#ifndef MY_STRATEGY_H
#define MY_STRATEGY_H

#include "strategy.h"

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 

AlCaponeStrategy : public Strategy { //zmente jmeno tridy 
public:

  virtual int operator()() { 
    
    // dopiste vlastni strategii 

    return   DECEIVE; // nebo COOPERATE;
  } 

  virtual void reward(int _reward) {     // informace o vysledku soubouje (CC/CD/DC/DD)
  	
  };
 

  virtual string getName() { return "AlCaponeStrategy"; }  // pojmenujte si ji  
}; 



#endif 
