#ifndef MY_STRATEGY_H_KOVAM_4AM
#define MY_STRATEGY_H_KOVAM_4AM

#include "strategy.h"

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 


class Revenger : public Strategy {
public:
  int pocetKol;
  int betrayCount;
  Revenger()  { reset(); }; 

  virtual int operator()() 
   { 
    if (betrayCount == 0 || betrayCount > 2 || pocetKol == 99) 
     return DECEIVE;
    else
     return COOPERATE;
   }
  virtual void reset() {betrayCount = 0;pocetKol = 0;}
  virtual void reward(int _reward) 
   {
    if (_reward == CD || _reward == DD) 
      betrayCount++;
    pocetKol++;
   }
  virtual string getName() { return "Revenger"; }  
 };



#endif 
