#ifndef ONDRA_H
#define ONDRA_H

#include "strategy.h"

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 


class Ondra1 : public Strategy { //zmente jmeno tridy 
public:
	Ondra1(){reset();};
	virtual void reset() { revenge = -1;last =COOPERATE; } 
	  
  	virtual int operator()() { 
    
    // dopiste vlastni strategii 
		if(revenge>0){//odplata
			//revenge--;    		
			last = DECEIVE;    		
    		return   DECEIVE; // nebo COOPERATE;
    	}
    	if(revenge<0){//svedomi
    		//revenge++;
    		last = COOPERATE;
    		return COOPERATE;
    	}
    	return last;
    		
  	} 

  	virtual void reward(int _reward) {
  		switch(_reward){
  		case CD:
  			revenge+=5 ;
  			break;
  		case DC:
  			revenge-=1 ;
  			break;
  		case CC:
  			revenge-=0 ;
  			break;
  		case DD:
  			revenge += 2;
  			break;
  		default:;
  		
  		}  	
  	};     // informace o vysledku soubouje (CC/CD/DC/DD)

 

  	virtual string getName() { return "Ondra1"; }  // pojmenujte si ji  
private:
	int revenge;
	int last;
}; 



#endif 
