#ifndef pilat_H
#define pilat_H

#include "strategy.h"

/*

Napiste si vlastni strategii.  

-->  upravte operator()  
	- vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

-->  muzete vyzit funkci reward(int _reward)     
	- vola se bezprostredne po souboji, prinasi vam informace 
		o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
	- int _reward : nabyva hodnot CC, CD, DC, DD 

--> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
(nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
pouzijte tedy  napr. sve jmeno)

*/ 


class PilatStrategy : public Strategy { //zmente jmeno tridy 
	public:
	PilatStrategy(){
			deceives_left=0;
		}
		virtual int operator()() { 
			if (deceives_left > 0) {
				deceives_left--;
				last_ret = DECEIVE;
				return DECEIVE;
			}
			last_ret = COOPERATE;
			return COOPERATE;
// dopiste vlastni strategii 

			//return   DECEIVE; // nebo COOPERATE;
		}
		virtual void reward(int _reward) {
			//if ((player == -1) && (last_ret == COMPETE) && (_reward == CD)) player = 1;
			//if ((player == -1) && (last_ret == DECEIVE) && (_reward == DC)) player = 2;
			if ((_reward == DC) || (_reward == CC)) 
				deceives_left+=2;
		};     // informace o vysledku soubouje (CC/CD/DC/DD)

		virtual string getName() { return "PilatStrategie"; }  // pojmenujte si ji  
	private:
		int deceives_left;
		int last_ret;
		//int player = -1;
};

#endif 
