#ifndef LANG_H
#define LANG_H

#include "strategy.h"

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 


class Langhammer : public Strategy { //zmente jmeno tridy 
	int rew;
	int rew_min;
	int prask;
public:
  virtual void reset(){
	rew=CC;
	prask=0;
	rew_min=CD;
	return;
  };

  virtual int operator()() { 
    // dopiste vlastni strategii 
    if (prask > 3) return DECEIVE;
    if(rew_min==CC || rew_min==DC) return DECEIVE;
    else return   COOPERATE; // nebo COOPERATE;
  } 

  virtual void reward(int _reward) {
  	rew_min=rew;
  	rew=_reward;
	if (rew== CD || rew==DD) prask++;
	else (prask=0);
	return;
  }     // informace o vysledku soubouje (CC/CD/DC/DD)

 

  virtual string getName() { return "Langhammer"; }  // pojmenujte si ji  
}; 



#endif 
