#ifndef MY_vavrp4am_H
#define MY_vavrp4am_H

#include "strategy.h"

/*

 Napiste si vlastni strategii.  

 -->  upravte operator()  
              - vlastni rozhodnuti, vraci bud COOPERATE nebo DECEIVE 

 -->  muzete vyzit funkci reward(int _reward)     
              - vola se bezprostredne po souboji, prinasi vam informace 
                o vyhre (muzete si napr. ulozit a vyuzit pri pristim rozhodovani) 
              - int _reward : nabyva hodnot CC, CD, DC, DD 

 --> prejmenujte tridu MyStrategy, upravte operator getName() a prejmenujte tento soubor 
     (nazvy volte tak, aby se nekolidovali se jmeny vasich kolegu, 
      pouzijte tedy  napr. sve jmeno)

*/ 


class vavrp4am_Strategy : public Strategy { //zmente jmeno tridy 
public:
  vavrp4am_Strategy(){ last_reward=-1; }

  virtual int operator()() { 
    
    	// dopiste vlastni strategii 

	int res = DECEIVE;
	
	if (last_reward==-1)
		return (COOPERATE);
	
	if (last_reward==CD)
		res = COOPERATE;

    	return (res); // nebo COOPERATE;
  } 

  virtual void reward(int _reward) {
	last_reward = _reward;
  }     // informace o vysledku soubouje (CC/CD/DC/DD)

 

  virtual string getName() { return "vavrp4am_Strategy"; }  // pojmenujte si ji

private:
	int last_reward;
}; 



#endif 
